#ifndef _MAIN_H_
#define _MAIN_H_


#include <inttypes.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>

// macros
#define SBI(port, bit)	(port |= _BV(bit))
#define CBI(port, bit)	(port &= ~_BV(bit))
#define NOP()	asm volatile("nop;")

//#define show_string_direct_pgm(text, a, b, c)  strcpy_P(tbuf, PSTR(text)); show_string_direct(tbuf, a, b, c)
//#define show_string_direct_pgm(text, a, b, c)  show_string_direct(text, a, b, c)

#define LB(x) ((x)&0x00FF)
#define HB(x) (((x)>>8)&0x00FF)

// Variables 
//extern volatile uint8_t g_swState ;

enum eModeList{
	MODE_METRONOME,
	MODE_TIMER
};

// Non-volatile settings
typedef struct {
	uint8_t curTempo;
	uint8_t curTime; // time setting of metronome (3-6)
	
	enum eModeList curMode;
	uint8_t timerMin;
	uint8_t timerSec;
}sEEPSettings; // g_eepSettings

#define ACTUAL_CLOCK_FREQ 4915200
//#define ACTUAL_CLOCK_FREQ 4964352

#define TEMPO_RANGE_MIN 32
#define TEMPO_RANGE_MAX 250

#define PWMEnable()  (TCCR1A |= 0b00100000)
#define PWMDisable() (TCCR1A &= 0b11001111)
//#define PWMEnable()  SBI(PORTB, PB3)
//#define PWMDisable() CBI(PORTB, PB3)

#define TESTMODE 0

#endif

